.nolist
include \masm32\include\masm32rt.inc
include \masm32\include\CpuID.INC

.data?
CmdLineBuffer	dd 40 dup(?)

.code
start:
	invoke GetCL, 1, offset CmdLineBuffer
	.Repeat
	.if CmdLineBuffer=="lluf" || al=="f"			; full
		print chr$(13, 10, 13, 10, "This is your CPU:", 13, 10)
		invoke ShowCPU, -1

	.elseif CmdLineBuffer=="rohs"  || al=="s"	; short
		print chr$(13, 10)
		invoke ShowCPU, 1
		print chr$(13, 10)

	.else
		invoke ShowCPU, 0
		print chr$(13, 10, 13, 10, "Your CPU supports SSE")
		print str$(CpuSSE), 13, 10, 13, 10
		print "For more info, use <cpuid short> or <cpuid full> from the commandline", 13, 10
	.endif
	.break .if CmdLineBuffer
	and CmdLineBuffer, 0
	print chr$(13, 10, 13, 10, "Press ESC to exit, s for short, f for full info", 13, 10)
	getkey
	.Until al==27
	exit
end start

[url=http://www.sandpile.org/ia32/cpuid.htm]Fairly complete list at sandpile[/url]

[url=http://en.wikipedia.org/wiki/CPUID]EAX=1: Processor Info and Feature Bits[/url]

This returns the CPU's stepping, model, and family information in EAX (also called the signature of a CPU), feature flags in EDX and ECX, and additional feature info in EBX.

The format of the information in EAX is as follows:

    * 3:0 - Stepping
    * 7:4 - Model
    * 11:8 - Family
    * 13:12 - Processor Type
    * 19:16 - Extended Model
    * 27:20 - Extended Family

[url=http://www.codinghorror.com/blog/archives/000364.html]Nasty Software Hacks and Intel's CPUID[/url]

Intel decided to make a new family code for the Pentium 4. That's where the fun begins.

The average person would think Intel would just increment the family code, making the Pentium 4 part of 'family 7'.
That does make sense, but Intel already has a family code 7 processor : the Itanium (it came before the Pentium 4,
even though the P4 hit the market first). Ok, no problem. Just make the Pentium 4's family code 8 instead of 7.

Wrong. Big problem.

Microsoft Windows NT 4.0 ran into a bit of a snag with "family 8." For those not schooled in the ways of binary,
the decimal number 8 is "1000" in binary. That's four binary digits. Four bits.

Four bits. Remember that, because it's important.

When Windows NT 4.0 and its six service packs were released, the largest CPU family code was 6.
That's "110" in binary. Only three bits. So the NT code only looks at the first three bits of the CPU family
when configuring the system.

If you haven't figured it out by now, the first three bits of 8 are zero, zero and, you guessed it, zero.
Windows NT goes wacko when it sees a CPU family zero. Serious wacko. Jack with an axe at the end of The Shining wacko.

OPT_WAIT	1	; wait until a key is pressed before closing the DOS box
OPT_Tmp2Asm	1
OcPT_Arg1	short
OcPT_Arg1	full
